
// Copyright: Hans de Nivelle, November 2005. 


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#ifndef LABEL_INCLUDED
#define LABEL_INCLUDED    1


#include <iostream>
#include <vector>


#include "variable.h"
#include "varatom.h"


class label
{
   int tag;

public: 
   explicit label( int tag )
      : tag( tag )
   {
   }

   bool operator == ( label other ) const 
   {
      return tag == other. tag;
   }

   bool operator != ( label other ) const 
   {
      return tag != other. tag;
   }

   void print( std::ostream& stream ) const 
   {
      stream << "label(" << tag << ")";
   }

};


inline std::ostream& operator << ( std::ostream& stream, label l )
{
   l. print( stream );
   return stream;
}


#endif


