
// Copyright: Hans de Nivelle, April 2006.


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#include "errors.h"


namespace parser
{


   std::ostream& operator << ( std::ostream& stream, const syntaxerror& err )
   {
      stream << "Syntax error: " << err. problem;
      stream << " in line " << err. linenumber;
      stream << " of inputstream " << err. streamname;  

      return stream;
   }
            


   std::ostream& operator << ( std::ostream& stream, const readerror& err )
   {
      stream << "Read error: " << err. problem;
      stream << " in line " << err. linenumber;
      stream << " of inputstream " << err. streamname;

      return stream;
   }
   

} 


