

// Copyright: Hans de Nivelle, April 2003. 


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#include "inputstream.h"

#include <sstream> 


namespace parser
{


   // If the stream is OK, and we did not reach EOF (which is implied
   //  by the fact that the stream is OK), then we read a character and
   // put it in nextchar.


   void inputstream::moveforward( ) 
   {
      if( stream && nextchar != EOF )
      {
      
         if( nextchar == '\t' )
            columnnumber += 5;         // An estimation. 
         else
         { 
            if( nextchar == '\n' ) 
            {
               linenumber ++ ;
               columnnumber = 1;
            }
            else
               columnnumber ++ ;
         }

         nextchar = stream. get( );
      }
   }


 
   inputstream::inputstream( std::istream& stream,
                             const std::string& name, 
                             unsigned int linenumber,
                             unsigned int columnnumber ) :
      stream( stream ),
      linenumber( linenumber ), 
      columnnumber( columnnumber - 1 ),
      nextchar( ' ' ),
      name( name ) 
   {  
      moveforward( );
   }


   
   inputstream::~inputstream( ) 
   {
      if( nextchar != EOF ) 
         stream. putback( nextchar );
   }
 
      

   std::string inputstream::inlineoffile( ) const
   {
      std::ostringstream s;

      s << "in line " << linenumber;
      s << " of file " << name;
      return s. str( );
   }

} 



