

// Copyright: Hans de Nivelle, April 2006.
// Modified for first-order, June 2006. 


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >


#include "token.h"


namespace parser
{


   std::ostream& operator << ( std::ostream& stream, 
		               const token& t )
   {
   
      switch( t. typeoftoken )
      {
      case token::token_lpar:
         stream << "lpar";
	 return stream;

      case token::token_rpar:
         stream << "rpar";
	 return stream;

      case token::token_comma:
         stream << "comma";
	 return stream;

      case token::token_dot:
         stream << "dot";
	 return stream;

      case token::token_slash:
         stream << "slash";
	 return stream;


      case token::token_false:
	 stream << "false";
	 return stream;

      case token::token_true:
	 stream << "true";
	 return stream;

      case token::token_not:
	 stream << "not";
	 return stream;

      case token::token_and:
         stream << "and";
	 return stream;

      case token::token_or:
         stream << "or";
	 return stream;

      case token::token_implies:
         stream << "implies";
	 return stream;

      case token::token_equiv:
         stream << "equiv";
	 return stream;

      case token::token_forall1:
         stream << "forall1";
	 return stream;

      case token::token_forall2:
         stream << "forall2";
	 return stream;

      case token::token_exists1:
         stream << "exists1";
	 return stream;

      case token::token_exists2:
         stream << "exists2";
	 return stream;

      case token::token_create:
         stream << "create";
	 return stream;

      case token::token_diseq:
         stream << "diseq";
	 return stream;

      case token::token_eq:
         stream << "eq";
	 return stream;


      case token::token_rulesystem:
         stream << "rulesystem";
	 return stream;

      case token::token_model:
         stream << "model";
	 return stream;

      case token::token_firstorder:
         stream << "firstorder";
	 return stream;

      case token::token_predicates:
         stream << "predicates";
	 return stream;

      case token::token_functions:
	 stream << "functions";
	 return stream;

      case token::token_end:
         stream << "end";
	 return stream;


      case token::token_string:
         stream << "string( ";
	 stream << t. stringattr;
	 stream << " )";
	 return stream;

      case token::token_unsigned:
	 stream << "unsigned( ";
	 stream << t. unsignedattr;
	 stream << " )";
	 return stream;


      case token::token_error:
         stream << "error";
	 return stream;

      case token::token_eof:
         stream << "eof";
	 return stream;

      }
      
      ASSERT( false ); exit(0);
   } 

} 


