

// Copyright: Hans de Nivelle, April 2007. 


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >


#ifndef STATISTICSCOLLECTOR_INCLUDED
#define STATISTICSCOLLECTOR_INCLUDED  1


#include <iostream>
#include <vector>


class statisticscollector
{

   double sum;
   unsigned int nr;

   std::vector< unsigned int > distr; 


public: 
   statisticscollector( )
      : sum(0.0),
        nr(0),
	distr( std::vector< unsigned int > ( ))
   {
   }

   void clear( );

   void insert( unsigned int x );


   static unsigned int getindex( unsigned int x );
      // Returns the index of x.

   static unsigned int getlowest( unsigned int i );
      // Returns the lowest number that obtains index i. 

   friend std::ostream& operator << ( std::ostream& , 
		                      const statisticscollector& ); 
};


std::ostream& operator << ( std::ostream& stream,
		            const statisticscollector& col ); 

#endif


