
// Copyright: Hans de Nivelle, Mai 2006.


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#ifndef SWLL_STATISTICS_COLLECTOR_INCLUDED
#define SWLL_STATISTICS_COLLECTOR_INCLUDED   1


#include <iostream>



namespace swll
{

   struct statistics_collector
   {
      unsigned int nr_calls; 

      unsigned int nr_passedsetproblem;
         // The number that failed in setproblem. 

      unsigned int nr_solution;
         // The number that has a solution.

      unsigned int max_lemmas;
      unsigned int max_size;

      double sum_lemmas;
      double sum_size;

      unsigned int printborder;

      statistics_collector( )
         : nr_calls( 0 ),
           nr_passedsetproblem( 0 ),
	   nr_solution( 0 ), 
	   max_lemmas( 0 ),
	   max_size( 0 ),
           sum_lemmas( 0.0 ),
	   sum_size( 0.0 ),
	   printborder( 10 )
      {
      }

   };


   std::ostream& operator << ( std::ostream& , 
		               const statistics_collector& );

} 


#endif


